//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Gold
#property indicator_width1  2
#property indicator_style2  STYLE_DOT

extern int UsePrice     = PRICE_MEDIAN;

double sine[];
double lead[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(8);
   SetIndexBuffer(0,sine); SetIndexLabel(0,"sine");
   SetIndexBuffer(1,lead); SetIndexLabel(1,"lead");
   return(0);
}
int deinit() { return(0); }
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
      
   //
   //
   //
   //
   //
         
   for(int i=limit; i>=0; i--)
   {
      double tsine, tlead;
         sineWave(iMA(NULL,0,1,0,MODE_SMA,PRICE_MEDIAN,i),tsine,tlead,i);
            sine[i] = tsine;
            lead[i] = tlead;
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double work[][12];
#define _price        0
#define _smooth       1
#define _detrender    2
#define _period       3
#define _Q1           4
#define _Q2           5
#define _I1           6
#define _I2           7
#define _Re           8
#define _Im           9 
#define _smoothPeriod 10
#define _smoothPrice  11

double Pi = 3.1415926535;
#define deg2rad Pi/180
#define rad2deg 180/Pi

//
//
//
//
//

void sineWave(double price, double& tsine, double& tlead, int r)
{
   if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars); r = Bars-r-1;
   if (r<5) { for (int k = 0; k<10; k++) work[r][k] = 0; tsine = 0; tlead=0; return;}

   //
   //
   //
   //
   //
   
      work[r][_price]     = price;
      work[r][_smooth]    = (4.0*work[r][_price]+3.0*work[r-1][_price]+2.0*work[r-2][_price]+work[r-3][_price])/10.0;
      work[r][_detrender] = (0.0962*work[r][_smooth]   +0.5769*work[r-2][_smooth]   -0.5769*work[r-4][_smooth]   -0.0962*work[r-6][_smooth])   *(0.075*work[r-1][_period]+0.54);
      work[r][_Q1]        = (0.0962*work[r][_detrender]+0.5769*work[r-2][_detrender]-0.5769*work[r-4][_detrender]-0.0962*work[r-6][_detrender])*(0.075*work[r-1][_period]+0.54); 
      work[r][_I1]        = work[r-3][_detrender];

      double jI = (0.0962*work[r][_I1]+0.5769*work[r-2][_I1]-0.5769*work[r-4][_I1]-0.0962*work[r-6][_I1])*(0.075*work[r-1][_period]+0.54); 
      double JQ = (0.0962*work[r][_Q1]+0.5769*work[r-2][_Q1]-0.5769*work[r-4][_Q1]-0.0962*work[r-6][_Q1])*(0.075*work[r-1][_period]+0.54);
      double I2 = work[r][_I1] - JQ; 
      double Q2 = work[r][_Q1] + jI;

         work[r][_I2] = 0.2*I2 + 0.8 * work[r-1][_I2];
         work[r][_Q2] = 0.2*Q2 + 0.8 * work[r-1][_Q2];

      double Re = work[r][_I2] * work[r-1][_I2] + work[r][_Q2] * work[r-1][_Q2];
      double Im = work[r][_I2] * work[r-1][_Q2] - work[r][_Q2] * work[r-1][_I2];

         work[r][_Re]     = 0.2*Re + 0.8 * work[r-1][_Re];
         work[r][_Im]     = 0.2*Im + 0.8 * work[r-1][_Im];
         work[r][_period] = work[r-1][_period];

      //
      //
      //
      //
      //
      
      if (work[r][_Im]!=0 && work[r][_Re]!=0) work[r][_period] = 2*Pi/MathArctan(work[r][_Im]/work[r][_Re]);
          work[r][_period]       = MathMax(MathMin(work[r][_period],1.5*work[r-1][_period]),0.67*work[r-1][_period]);
          work[r][_period]       = MathMax(MathMin(work[r][_period],50),6);
          work[r][_period]       = 0.2 *work[r][_period] + 0.8 *work[r-1][_period];
          work[r][_smoothPeriod] = 0.33*work[r][_period] + 0.67*work[r-1][_smoothPeriod];
          work[r][_smoothPrice]  = (4*work[r][_price]+3*work[r-1][_price]+2*work[r-2][_price]+work[r][_price])/10.0;

      //
      //
      //
      //
      //
      
         double dcPeriod = MathFloor(work[r][_smoothPeriod]+0.5); 
         double realPart = 0; 
         double imagPart = 0; 
         double dcPhase  = 0;

         for (int j=0;j<dcPeriod;j++)
         {
            realPart += MathSin(2*Pi*j/dcPeriod)*(work[r-j][_smoothPrice]);
            imagPart += MathCos(2*Pi*j/dcPeriod)*(work[r-j][_smoothPrice]); 
         }
         if (MathAbs(imagPart) > 0) dcPhase = MathArctan(realPart/imagPart);
         if (MathAbs(imagPart) <= 0.001) 
            if (realPart >= 0.0)
 	               dcPhase +=  Pi/2;
 	         else  dcPhase += -Pi/2;
						dcPhase +=  Pi/2;
         if (work[r][_smoothPeriod]!=0) dcPhase = dcPhase+2*Pi/work[r][_smoothPeriod];
               

      //
      //
      //
      //
      //
      
      if (imagPart < 0          ) dcPhase += Pi;
      if (dcPhase  > 315/deg2rad) dcPhase -= Pi*2.0;

   tsine = MathSin(dcPhase); 
   tlead = MathSin(dcPhase+45.0*deg2rad);
}